@make(ais)
@aiInfo(topic=<[Combined with AI-00738]>,
number=[AI-00845/02],
classcode=[na],
statuscode=[na],
mainref=[08.05@\(05)],
date=[91-02-11])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
!class @cbon()no action
!status no action
@end(toplines)
!status received 89-11-19
@topic{!topic [Combined with AI-00738]}@cboff()
@end(history)

@subheading[!summary 89-11-19]


@subheading[!question 89-11-19]


@subheading[!recommendation 89-11-19]


@subheading[!discussion 89-11-19]


@begin(appendix)
@subheading[!appendix 89-12-08]
@begin(sectionGroup)
@mybar()

!section 08.05    (05) Mats Weber  89-10-03                          83-01335
!version 1983
!topic Renaming subcomponents of an IN mode parameter
@end(sectionGroup)

Consider the following piece of code:

    type Identifier (Valid : Boolean := False) is
       record
          case Valid is
             when True =>
                Value : Natural;
             when False =>
                null;
          end case;
       end record;

    procedure P (Item : in Identifier) is

       Item_Value : Natural renames Item.Value;  -- *

    begin
       -- do something with Item_Value.
    end P;

Is the *-marked renaming declaration correct ?

LRM 8.5(5) says "the following restrictions apply to the renaming of a
subcomponent that depends on discriminants of a VARIABLE" but Item is
a CONSTANT according to LRM 6.2(3).
(Note that Constraint_Error should be raised if Item.Valid is False).

Is this analysis correct ? If it is, then this example should be included
in the ACVC suite because all the compilers I have tested so far
consider Item as a variable and do not accept the renaming.

@begin(sectionGroup)
@mybar()

!section 08.05    (05) Norman Cohen  89-12-08                        83-01346
!version 1983
!topic Renaming subcomponents of an IN mode parameter
@end(sectionGroup)
!reference AI-00845

This case is covered by AI-00738.

@end(appendix)
